﻿@model eCommerce.Services.Model.Newsletter
@{
    ViewBag.Title = "Newsletter";
    Layout = "~/Views/Shared/_Layout.cshtml";
}


<div class="page-header">
    <h1 class="page-title">Newsletter</h1>
    <ol class="breadcrumb">
        <li class="active">Crear / Editar</li>
    </ol>
</div>

<div class="page-content">
    <div class="panel">
        <div class="panel-body">
            <div class="col-md-12">
                <div id="example">
                    @using (Html.BeginForm("NewsletterUpdate", "Newsletter", FormMethod.Post, new { @class = "form-horizontal", @autocomplete = "off" }))
                    {
                        <div class="form-group" style="margin-bottom:5px;">
                            <label class="col-sm-2 control-label">Campaña</label>
                            <div class="col-sm-9">
                                <input type="text" class="form-control" name="Campaign" value="@Model.Campaign" />
                            </div>
                        </div>
                        <div class="form-group" style="margin-bottom:10px;">
                            <label class="col-sm-2 control-label"></label>
                            <div class="col-sm-9">
                                <label>Este campo se utiliza para la URL del template, no usar espacios, usar guiones (-) para separar las palabras.</label>
                            </div>
                        </div>
                        <div class="form-group">
                            <label class="col-sm-2 control-label">Título</label>
                            <div class="col-sm-9">
                                <input type="text" class="form-control" name="Title" value="@Model.Title" />
                            </div>
                        </div>
                        <div class="form-group">
                            <label class="col-sm-2 control-label">Notas</label>
                            <div class="col-sm-9">
                                <textarea class="form-control" name="Notes" rows="4">@Model.Notes</textarea>
                            </div>
                        </div>
                        <div class="form-group">
                            <label class="col-sm-2 control-label">Fecha de Vencimiento</label>
                            <div class="input-group col-md-2">
                                <span class="input-group-addon">
                                    <i class="icon wb-calendar" aria-hidden="true"></i>
                                </span>
                                    <input type="text" class="form-control" name="ExpirationDate" value="@(Model.ExpirationDate.HasValue ? Model.ExpirationDate.Value.ToShortDateString() : "")" data-plugin="datepicker" />
                            </div>
                        </div>
                        @*<div class="form-group">
                            <label class="col-sm-2 control-label">Mostrar Stock</label>
                            <div class="col-sm-9">
                                <div class="checkbox-custom checkbox-primary">
                                    <input type="checkbox" name="ShowStock" class="js-switch-small form-control" data-plugin="switchery" data-size="small" @(Model.ShowStock ? "checked=\"checked\"" : "") data-switchery="true" style="display: none;">
                                </div>
                            </div>
                        </div>*@
                        @*<div class="form-group">
                            <label class="col-sm-2 control-label">Enviado</label>
                            <div class="col-sm-9">
                                <div class="checkbox-custom checkbox-primary">
                                    <input type="checkbox" name="Sent" class="js-switch-small form-control" data-plugin="switchery" data-size="small" @(Model.Sent ? "checked=\"checked\"" : "") data-switchery="true" style="display: none;">
                                </div>
                            </div>
                        </div>*@
                        <div class="form-group">
                            <label class="col-sm-2 control-label">Activo</label>
                            <div class="col-sm-9">
                                <div class="checkbox-custom checkbox-primary">
                                    @if (Model.NewsletterId == -1)
                                    {
                                        <input type="checkbox" name="Active" class="js-switch-small form-control" data-plugin="switchery" data-size="small" checked data-switchery="true" style="display: none;">
                                    }
                                    else
                                    {
                                        <input type="checkbox" name="Active" class="js-switch-small form-control" data-plugin="switchery" data-size="small" @(Model.Active ? "checked=\"checked\"" : "") data-switchery="true" style="display: none;">
                                    }
                                    
                                </div>
                            </div>
                        </div>
                        <div class="form-group">
                            <label class="col-sm-2 control-label">Ordernar Por</label>
                            <div class="col-sm-2">
                                <select class="form-control" name="OrderById" id="OrderById" data-plugin="select2">
                                    <option value="1">Default</option>
                                    @if (TempData["OrderByIds"] != null)
                                    {
                                        foreach (var item in (SelectList)TempData["OrderByIds"])
                                        {
                                            <option value="@item.Value" selected="@item.Selected">@item.Text</option>
                                        }
                                    }
                                </select>
                            </div>
                        </div>
                        <div class="form-group">
                            <label class="col-sm-2 control-label">Productos</label>
                            <div class="col-sm-6">
                                <select class="form-control" name="ProductId" id="ProductId" data-plugin="select2">
                                    <option value=""></option>
                                    @if (TempData["Products"] != null)
                                    {
                                        foreach (var item in (SelectList)TempData["Products"])
                                        {
                                            <option value="@item.Value" selected="@item.Selected">@item.Text</option>
                                        }
                                    }
                                </select>
                            </div>
                            <div class="col-sm-1">
                                <button type="button" class="btn btn-outline btn-primary" onclick="AddProduct()">
                                    <i class="icon wb-plus" aria-hidden="true"></i> Agregar</button>
                            </div>
                            
                            <div class="col-sm-1">
                                <button type="button" class="btn btn-outline btn-primary" onclick="OpenModal(1)" style="margin-left:15px;">
                                    <i class="icon wb-plus" aria-hidden="true"></i> Masivo
                                </button>
                            </div>

                            @*<div class="col-sm-1">
                                <button type="button" class="btn btn-outline btn-primary" onclick="OpenModal(2)" style="margin-left:26px;">
                                    <i class="icon wb-plus" aria-hidden="true"></i> Por Compra
                                </button>
                            </div>*@
                        </div>
                        <div class="form-group">
                            <label class="col-sm-2 control-label">Actualizar Precios</label>
                            <div class="col-sm-9">
                                <div class="checkbox-custom checkbox-primary">
                                    <input type="checkbox" name="HasSpecialPrice" class="js-switch-small form-control" data-plugin="switchery" data-size="small" @(Model.HasSpecialPrice ? "" : "checked=\"checked\"") data-switchery="true" style="display: none;">
                                </div>
                            </div>
                        </div>
                        <div class="form-group">
                            <label class="col-sm-2 control-label">Usar tope de descuento</label>
                            <div class="col-sm-9">
                                <div class="checkbox-custom checkbox-primary">
                                    <input type="checkbox" name="UseMaxDiscount" id="UseMaxDiscount" class="js-switch-small form-control" data-plugin="switchery" data-size="small" @(Model.UseMaxDiscount ? "checked=\"checked\"" : "") data-switchery="true" style="display: none;">
                                </div>
                            </div>
                        </div>


                        <div class="form-group">
                            <div class="row" style="margin-top:20px;">
                                <div class="col-sm-4">
                                    <h4>Productos</h4>
                                </div>
                                
                                <div class="col-sm-4 pull-right">
                                        <div class="input-group" style="width:100px;float:right;">
                                            <input type="text" class="form-control" id="DiscountPercentage" value="" /><span class="input-group-addon">%</span>
                                        </div>
                                        <button type="button" class="btn btn-outline btn-primary" onclick="ApplyDiscount()" style="float:right;margin-right:10px;">
                                            Aplicar
                                        </button>
                                        <button type="button" class="btn btn-outline btn-primary" onclick="RemoveDiscount()" style="float:right;margin-right:10px;">
                                            Remover
                                        </button>
                                </div>
                                <div class="col-sm-1 pull-right" style="margin-right:15px;">
                                    <button type="button" class="btn btn-outline btn-primary" onclick="RemoveOldPrices()" style="margin-right:20px;">
                                        Borrar precios anteriores
                                    </button>
                                </div>
                            </div>
                            <div id="NewsletterItemList" class="row">
                                @Html.Partial("_NewsletterItemsList",Model.NewsletterProducts)
                            </div>
                        </div>
                        <div class="text-right">
                            <button type="submit" class="btn btn-primary btn-success" id="btnSave">Grabar</button>
                            <button type="button" class="btn btn-default" onclick="window.location.href = '/Newsletter'">Cancelar</button>
                            @Html.HiddenFor(model => model.NewsletterId)
                        </div>
                    }
                </div>
            </div>
        </div>
    </div>
</div>

<!-- Massive Add Modal -->
<div class="modal fade" id="MassiveAdd" aria-hidden="false" aria-labelledby="checks" role="dialog">
    <div class="modal-dialog modal-lg">
        <form class="modal-content" id="modalSearchByProduct" method="post" action="#">
            <div class="modal-header">
                <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                    <span aria-hidden="true">×</span>
                </button>
                <h4 class="modal-title" id="exampleFormModalLabel">Agrego masivo de productos</h4>
            </div>
            <div class="modal-body">
                <div class="form-group">
                    <label class="col-sm-2 control-label">Título</label>
                    <div class="col-sm-9">
                        <input type="text" class="form-control" id="ProductTitle" />
                    </div>
                </div>
                <br/>
                @*<div class="form-group">
                    <label class="col-sm-2 control-label">Marca</label>
                    <div class="col-sm-9">
                        <select class="form-control" name="BrandId" id="BrandId" data-plugin="select2">
                            <option value="">Ninguna</option>
                            @if (TempData["Brands"] != null)
                            {
                                foreach (var item in (SelectList)TempData["Brands"])
                                {
                                    <option value="@item.Value" selected="@item.Selected">@item.Text</option>
                                }
                            }
                        </select>
                    </div>
                </div>*@
                <div class="form-group">
                    <div class="col-sm-11">
                        <button type="submit" class="btn btn-primary" id="btnSearch" onclick="massiveSearch()" style="margin-top:5px;float:right;">Buscar</button>
                        </div>
                    </div>
                <br/>
                <div class="row clearfix"></div>
                    <h5 id="errorMsg" style="display:none;"></h5>
                    <div id="SearchedProductsList" class="row" style="margin:0">
                    </div>
                </div>
        </form>
    </div>
</div>
<!-- Massive Add Modal End -->
<!-- Order Add Modal-->
<div class="modal fade" id="OrderAdd" aria-hidden="false" aria-labelledby="checks" role="dialog">
    <div class="modal-dialog modal-lg">
        <form class="modal-content" id="modalSearchByProduct" method="post" action="#">
            <div class="modal-header">
                <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                    <span aria-hidden="true">×</span>
                </button>
                <h4 class="modal-title" id="exampleFormModalLabel">Agrego masivo de productos</h4>
            </div>
            <div class="modal-body">
                <br />
                <div class="form-group">
                    <label class="col-sm-2 control-label">Compras</label>
                    <div class="col-sm-9">
                        <select class="form-control" name="PurchaseId" id="PurchaseId" data-plugin="select2">
                            <option value="">Ninguna</option>
                            @if (TempData["Purchases"] != null)
                            {
                                foreach (var item in (SelectList)TempData["Purchases"])
                                {
                                    <option value="@item.Value" selected="@item.Selected">@item.Text</option>
                                }
                            }
                        </select>
                    </div>
                </div>
                <div class="form-group">
                    <div class="col-sm-11">
                        <button type="submit" class="btn btn-primary" id="btnSearch" onclick="searchByPurchase()" style="margin-top:5px;float:right;">Buscar</button>
                    </div>
                </div>
                <br />
                <div class="row clearfix"></div>
                <h5 id="errorMsg" style="display:none;"></h5>
                <div id="SearchedProductsByPurchaseList" class="row" style="margin:0">
                </div>
            </div>
        </form>
    </div>
</div>
<!-- Order Add Modal End-->

<style type="text/css">
    .select2-close-mask {
        z-index: 2099;
    }

    .select2-dropdown {
        z-index: 3051;
    }
</style>



@section Scripts {

    <script type="text/javascript">

        $(document).ready(function () {
            $("#UseMaxDiscount").change(function () {
                debugger;
                $(".discount").each(function () {
                    debugger;
                    UpdateDiscount($(this));
                });
            });
        });

        function AddProduct()
        {
            var prodId = $("#ProductId").val();
            if (prodId > 0) {
                $.ajax({
                    type: "GET",
                    cache: false,
                    url: "/Newsletter/GetProduct",
                    data: { productId : prodId },
                    success: function (data) {
                        var row_number = $("#productsTable tr").length;
                        if (data.OldPrice == null) {
                            data.OldPrice = 0;
                        }
                        var row = [
                            '<tr>',
                                '<input type="hidden" name="ProductId_' + row_number + '" id="ProductId_' + row_number + '" value=' + data.ProductId + ' />',
                                '<input type="hidden"' + '" id="Real_' + row_number + '" value=' + data.Price.toFixed(2).replace('.', ',') + ' />',
                                '<input type="hidden"' + '" id="MaxDiscount_' + row_number + '" value=' + data.MaxDiscount + ' />',
                                '<td>' + data.Code + '</td>',
                                '<td>' + data.Title + '</td>',
                                '<td>' + data.Category + '</td>',
                                '<td><div class="input-group"><span class="input-group-addon">$</span><input type="text" class="form-control" name="Price_' + row_number + '" id="Price_' + row_number + '" value=' + data.Price.toFixed(2).replace('.', ',') + ' ></div></td>',
                                '<td><div class="input-group"><span class="input-group-addon">$</span><input type="text" class="form-control" name="Old_' + row_number + '" id="Old_' + row_number + '" value= ></div></td>',
                                '<td><div class="input-group"><span class="input-group-addon">%</span><input type="text" class="form-control discount" onblur="UpdateDiscount(this)" name="Discount_' + row_number + '" id="Discount_' + row_number + '" ></div></td>',
                                '<td><div class="input-group"><input type="text" class="form-control" name="Observation_' + row_number + '" id="Observation_' + row_number + '" ></div></td>',
                                '<td class="actions text-center vertical-align"><a href="javascript:void(0);" class="btn btn-sm btn-icon btn-pure btn-default on-default remove-row" data-toggle="tooltip" data-original-title="Borrar"><i class="icon wb-trash" aria-hidden="true"></i></a></td>',
                            '</tr>'
                        ].join(' ');

                        $("#productsTable").append(row);
                    }
                });
            }
        }

        $("#productsTable").on('click', '.remove-row', function () {
            $(this).parent().parent().remove();
        });


        (function () {
            $('.form-horizontal').formValidation({
                framework: "bootstrap",
                button: {
                    selector: '#btnSave',
                    disabled: 'disabled'
                },
                icon: null,
                fields: {
                    Name: {
                        validators: {
                            notEmpty: {
                                message: 'El campo Nombre es requerido.'
                            }
                        }
                    },
                    Title: {
                        validators: {
                            notEmpty: {
                                message: 'El campo Titulo es requerido.'
                            }
                        }
                    },
                    Campaign: {
                        validators: {
                            notEmpty: {
                                message: 'El campo Campaña es requerido.'
                            }
                        }
                    }
                }
            });
        })();

        function OpenModal(n) {
            switch (n) {
                case 1:
                    $("#MassiveAdd").modal();
                    break;
                case 2:
                    $("#OrderAdd").modal();
                    break;
                default:

            }
            
        }

        function massiveSearch() {
            event.preventDefault();
            var brandId = $("#BrandId").val();
            var productTitle = $("#ProductTitle").val();
            if (brandId != "" || productTitle != "") {
                $.ajax({
                    url: "/Newsletter/MassiveSearch/",
                    type: "POST",
                    data: { BrandId: brandId, Title: productTitle },
                    success: function (data, textStatus, jqXHR) {
                        $("#SearchedProductsList").css("display", "block");
                        $('#SearchedProductsList').html(data);
                        $("#errorMsg").css("display", "none");
                        $("#SearchedProductList").css("display", "block");
                    }
                });
            }
            else {
                $("#SearchedProductsList").css("display", "none");
                $("#errorMsg").css("display", "block");
                $("#errorMsg").text("Ingrese un filtro");
            }
        }

        function searchByPurchase()
        {
            event.preventDefault();
            var purchaseId = $("#PurchaseId").val();
            if (purchaseId != "") {
                $.ajax({
                    url: "/Newsletter/MassiveSearchByPurchase/",
                    type: "POST",
                    data: { PurchaseId: purchaseId },
                    success: function (data, textStatus, jqXHR) {
                        $("#SearchedProductsByPurchaseList").css("display", "block");
                        $('#SearchedProductsByPurchaseList').html(data);
                        $("#errorMsg").css("display", "none");
                        $("#SearchedProductByPurchaseList").css("display", "block");
                    }
                });
            }
            else {
                $("#SearchedProductsByPurchaseList").css("display", "none");
                $("#errorMsg").css("display", "block");
                $("#errorMsg").text("Ingrese un filtro");
            }
        }

        function MassiveAdd()
        {
            event.preventDefault();
            var productIds = [];
            var productId;
            $("input[class*='check']:checked").each(function () {
                productId = $(this).attr("class").split('-')[1];
                $("#ProductId").val(productId);
                AddProduct();
            });
            if ($('#MassiveAdd').hasClass('in')) {
                $("#MassiveAdd").modal('hide');
                ResetModalFields(1);
            } else {
                $("#OrderAdd").modal('hide');
                ResetModalFields(2);
            }
        }

        function SelectAll(type) {
            event.preventDefault();
            if (type == 1) {
                $("input[class*='check']").each(function () {
                    $(this).prop('checked', true);
                    $("#btnSelectAll").text("Desseleccionar Todos");
                    $("#btnSelectAll").attr("onclick","SelectAll(0)");
                });
            } else {
                $("input[class*='check']").each(function () {
                    $(this).prop('checked', false);
                    $("#btnSelectAll").text("Seleccionar Todos");
                    $("#btnSelectAll").attr("onclick", "SelectAll(1)");
                });
            }
        }

        function ResetModalFields(n)
        {
            switch (n) {
                case 1:
                    $("#SearchedProductsList").css("display", "none");
                    $("#SearchedProductsList").html('');
                    $("#ProductTitle").val("");
                    $("#BrandId").val('');
                    $("#BrandId").select2();
                    break;
                case 2:
                    $("#SearchedProductsByPurchaseList").css("display", "none");
                    $("#SearchedProductsByPurchaseList").html('');
                    $("#PurchaseId").val('');
                    $("#PurchaseId").select2();
                    break;
                default:
            }
            ResetCheckBoxes();
            $("#ProductId").val('');
        }

        function ResetCheckBoxes()
        {
            debugger;
            $("input[class*='check']").each(function () {
                debugger;
                $(this).prop('checked', false);
            });
        }

        function ApplyDiscount()
        {
            debugger;
            var percentage = $("#DiscountPercentage").val();
            var useMaxDiscount = $('#UseMaxDiscount').is(':checked');
            if (percentage != '') {
                $("input[id*='Price'").each(function () {
                    var n = $(this).attr('id').split('_')[1];
                    if ( $("#Real_" + n).val() == '') {
                        $("#Real_" + n).val($(this).val());
                    }
                    debugger;
                    if ($("#Old_" + n).val() == '') {
                        $("#Old_" + n).val($(this).val());
                    }

                    if (useMaxDiscount && parseFloat(percentage) >= parseFloat($("#MaxDiscount_" + n).val())) {
                        $(this).val((parseFloat($("#Old_" + n).val().replace(',', '.').replace(' ', '')) - parseFloat($("#Old_" + n).val().replace(',', '.').replace(' ', '')) / 100 * parseFloat($("#MaxDiscount_" + n).val())).toFixed(2).replace('.', ','));
                        $(this).css("box-shadow", "0 0 5px rgb(228, 21, 21)");
                        $(this).css("border", "1px solid rgb(228, 21, 21)");
                        $("#Discount_" + n).css("box-shadow", "0 0 5px rgb(228, 21, 21)");
                        $("#Discount_" + n).css("border", "1px solid rgb(228, 21, 21)");
                        $("#Discount_" + n).val($("#MaxDiscount_" + n).val());
                    } else {
                        $(this).val((parseFloat($("#Old_" + n).val().replace(',', '.').replace(' ', '')) - parseFloat($("#Old_" + n).val().replace(',', '.').replace(' ', '')) / 100 * parseFloat(percentage)).toFixed(2).replace('.', ','));
                        $(this).css("box-shadow", "");
                        $(this).css("border", "");
                        $("#Discount_" + n).css("box-shadow", "");
                        $("#Discount_" + n).css("border", "");
                        $("#Discount_" + n).val(percentage);
                    }
                    
                });
                toastr.success('Descuento del ' + percentage + '% aplicado');
            } else {
                toastr.warning('Ingrese un porcentaje de descuento');
            }
        }

        function RemoveDiscount() {
            $("input[id*='Old'").each(function () {
                var n = $(this).attr('id').split('_')[1];
                $("#Price_" + n).val($("#Real_" + n).val());
                $(this).val('');
                $("#Price_" + n).css("box-shadow", "");
                $("#Price_" + n).css("border", "");
                $("#Discount_" + n).val('');
                $("#Discount_" + n).css("box-shadow", "");
                $("#Discount_" + n).css("border", "");
            });
            toastr.info('Descuento removido');
        }

        function RemoveOldPrices() {
            $("input[id*='Old'").each(function () {
                $(this).val('');
            });
            toastr.info('Precios anteriores removidos');
        }
        
        function UpdateDiscount(elm)
        {
            debugger;
            var percentage = $(elm).val();
            var n = $(elm).attr('id').split('_')[1];
            var useMaxDiscount = $('#UseMaxDiscount').is(':checked')

            if (percentage.trim() != "") {
                if ($("#Old_" + n).val() == '') 
                    $("#Old_" + n).val($("#Price_" + n).val());
                        
                if (useMaxDiscount && parseFloat(percentage) >= parseFloat($("#MaxDiscount_" + n).val())) {
                    $(elm).val($("#MaxDiscount_" + n).val());
                    $("#Price_" + n).val((parseFloat($("#Old_" + n).val().replace(',', '.').replace(' ', '')) - parseFloat($("#Old_" + n).val().replace(',', '.').replace(' ', '')) / 100 * parseFloat($("#MaxDiscount_" + n).val())).toFixed(2).replace('.', ','));
                    $("#Price_" + n).css("box-shadow", "0 0 5px rgb(228, 21, 21)");
                    $("#Price_" + n).css("border", "1px solid rgb(228, 21, 21)");
                    $(elm).css("box-shadow", "0 0 5px rgb(228, 21, 21)");
                    $(elm).css("border", "1px solid rgb(228, 21, 21)");
                } else {
                    $("#Price_" + n).val((parseFloat($("#Old_" + n).val().replace(',', '.').replace(' ', '')) - parseFloat($("#Old_" + n).val().replace(',', '.').replace(' ', '')) / 100 * parseFloat(percentage)).toFixed(2).replace('.', ','));
                    $("#Price_" + n).css("box-shadow", "");
                    $("#Price_" + n).css("border", "");
                    $(elm).css("box-shadow", "");
                    $(elm).css("border", "");
                }
            } else {
                $("#Price_" + n).val($("#Old_" + n).val());
                $("#Old_" + n).val('')
                $("#Price_" + n).css("box-shadow", "");
                $("#Price_" + n).css("border", "");
                $(elm).css("box-shadow", "");
                $(elm).css("border", "");
            }
        }
    </script>
}

